{
  "openapi": "3.0.2",
  "info": {
    "title": "Schematics Service API",
    "description": "## Introduction\n\nIBM Cloud® Schematics uses Terraform to help you define cloud resources with code. It makes simple to manage your infrastructure by using scripts. [Terraform](https://www.terraform.io/) is an open source tool that is developed by HashiCorp that allows consistent and reliable provisioning of resources, simple to build complex, multitier cloud environments quickly.\n\nIBM Cloud Schematics and Ansible are complementary tools. Ansible helps with provisioning, configuration management, and deploying secure applications. IBM Cloud Schematics supports [Ansible Galaxy](https://cloud.ibm.com/docs/schematics?topic=schematics-getting-started-ansible#ansible-galaxy), making automation easier by using `roles` and `collections`.\n\nThe following list provides the detailed documentation.\n\n- [Schematics getting started tutorial](https://cloud.ibm.com/docs/schematics?topic=schematics-getting-started)\n- [About Schematics documentation](https://cloud.ibm.com/docs/schematics?topic=schematics-learn-about-schematics)\n- [About Schematics and Ansible documentation](https://cloud.ibm.com/docs/schematics?topic=schematics-getting-started-ansible)\n\nThe code examples on this tab use the IBM Cloud Schematics SDK for Java.\n\nGradle\n\n```groovy\ncompile group: 'com.ibm.cloud', name: 'schematics', version: '0.+'\n```\n\nMaven\n\n[Maven installation instructions](https://github.com/IBM/schematics-java-sdk/#maven)\n\nGitHub\n\n<https://github.com/ibm/schematics-java-sdk>\n\nThe code examples on this tab use the IBM Cloud Schematics SDK for Node.js.\n\nInstallation\n\n```bash\nnpm install --save @ibm-cloud/ibm-schematics\n```\n\nGitHub\n\n<https://github.com/ibm/schematics-node-sdk>\n\nThe code examples on this tab use the IBM Cloud Schematics SDK for Python.\n\nInstallation\n\n```bash\npip3 install ibm-schematics\n```\n\nGitHub\n\n<https://github.com/ibm/schematics-python-sdk>\n\nThe code examples on this tab use the IBM Cloud Schematics SDK for Go.\n\nInstallation\n\n```bash\ngo get -u github.com/IBM/schematics-go-sdk \n```\n\nGitHub\n\n<https://github.com/ibm/schematics-go-sdk>\n\n## Before you begin\n\n- Make sure that you have access to a paid IBM Cloud account. \n- Learn more [about IBM Cloud Schematics](https://cloud.ibm.com/docs/schematics?topic=schematics-learn-about-schematics). \n- Familiarize yourself with the [key terms](https://cloud.ibm.com/docs/schematics?topic=schematics-sch-terms), such as Workspaces, Terraform templates, and resources. \n- Find the [IBM Cloud resources](https://ibm-cloud.github.io/tf-ibm-docs/?cm_mc_uid=71885624553615726236960&cm_mc_sid_50200000=38067391572884797521) that you want to create with IBM Cloud Schematics.\n- Use [sample Terraform templates](https://github.com/IBM-Cloud/terraform-provider-ibm/tree/master/examples) as a basis for your own Terraform template.  \n- Review how to [create a Terraform template and properly store it](https://cloud.ibm.com/docs/schematics?topic=schematics-create-tf-config). \n- Plan your [workspace structure](https://cloud.ibm.com/docs/schematics?topic=schematics-sch-create-wks). \n- Learn how to use IBM Cloud Schematics to [manage the lifecycle](https://cloud.ibm.com/docs/schematics?topic=schematics-manage-lifecycle) of your resources. \n\n## Authentication\n\nThe IBM Cloud Schematics API uses Identity and Access Management (IAM) to authenticate requests. Pass a bearer token in an Authorization header or an `apikey`. Tokens support authenticated requests without embedding service credentials in every call. API keys use basic authentication. For more information, see [IAM access](https://cloud.ibm.com/docs/account?topic=account-userroles).\n\nThe IBM Cloud Schematics API uses Identity and Access Management (IAM) for authentication. You can authenticate by passing a bearer token in the Authorization header or by using an API key. Bearer tokens allow secure requests without including service credentials each time. API keys use basic authentication. For more information, see [IAM access](https://cloud.ibm.com/docs/account?topic=account-userroles).\n\n### Authentication with external configuration\n\nIn this scenario, configuration is defined by using an external credentials file and an authenticator, which is created by the SDK’s authenticator factory during client initialization. This approach avoids hardcoding credentials in the application code.\n\nThe default credentials file is named `ibm-credentials.env`. By default, the SDK looks for this file in the current working directory or the user's home directory. You can customize the file's path and name by using the `IBM_CREDENTIALS_FILE` environment variable.\n\nEach configuration property's name includes the service name and the attribute name, following the format `<service-name>_<attribute-name>`.\n\nUsing a `.env` file is optional, these properties can be set as environment variables with the same names in the application's runtime environment.\n\nExplanation of the variables used in the authentication examples.\n\n<table style=\"color: #c6c6c6\">\n    <tr style=\"background: #262626\">\n        <td>`{apikey}`</td>\n        <td>IAM API key</td>\n    </tr>\n    <tr style=\"background: #262626\">\n        <td>`{url}`</td>\n        <td>URL of Schematics instance</td>\n    </tr>\n</table>\n\nThe SDK manages the IAM token automatically. Replace `{apikey}` with your actual API key and `{url}` with the service endpoint URL.\n\n```generic\nIBM_SCHEMATICS_URL={url}\nIBM_SCHEMATICS_APIKEY={apikey}\n```\n\n```java\nimport com.ibm.cloud.schematics.v1.Schematics;\n\nSchematics service = Schematics.newInstance(\"ibm-schematics\");\n```\n\n```javascript\nconst SchematicsV1 = require('@ibm-cloud/ibm-schematics/schematics/v1');\n\nconst service = SchematicsV1.newInstance({\n    serviceName: 'ibm-schematics'\n});\n```\n\n```python\nfrom ibm_schematics.schematics_v1 import SchematicsV1\nfrom ibm_cloud_sdk_core.authenticators import IAMAuthenticator\n\nservice = SchematicsV1.new_instance(service_name=\"ibm-schematics\")\n```\n\n```go\nimport (\n    \"github.com/IBM/schematics-go-sdk/schematicsv1\"\n)\nschematicsService, err := schematicsv1.NewSchematicsV1UsingExternalConfig(&schematicsv1.SchematicsV1Options{\n    ServiceName: \"ibm-schematics\",\n})\n```\n\n### Programmatic authentication\n\nIn this scenario authentication that is configured by constructing an authenticator instance provides the configuration attributes programmatically and then passing this instance to a client instantiation.\n\nSDK managing the IAM token.\n\n```java\nimport com.ibm.cloud.schematics.v1.Schematics;\nimport com.ibm.cloud.sdk.core.security.IamAuthenticator;\n\nIamAuthenticator authenticator = new IamAuthenticator(\"{apikey}\");\n\nSchematics service = new Schematics(Schematics.DEFAULT_SERVICE_NAME, authenticator);\n\nservice.setServiceUrl(\"{url}\");\n```\n\n```javascript\nconst SchematicsV1  = require('@ibm-cloud/ibm-schematics/schematics/v1');\nconst { IamAuthenticator } = require('ibm-cloud-sdk-core');\n\nconst authenticator = new IamAuthenticator({\n    apikey: '{apikey}'\n});\n\nconst service = new SchematicsV1({\n    authenticator: authenticator\n});\n\nservice.setServiceUrl('{url}');\n```\n\n```python\nfrom ibm_schematics.schematics_v1 import SchematicsV1\nfrom ibm_cloud_sdk_core.authenticators import IAMAuthenticator\n\nauthenticator = IAMAuthenticator('{apikey}')\n\nservice = SchematicsV1(authenticator=authenticator)\n\nservice.set_service_url('{url}')\n```\n\n```go\nimport (\n    \"github.com/IBM/go-sdk-core/v4/core\"\n    \"github.com/IBM/schematics-go-sdk/schematicsv1\"\n)\nauthenticator := &core.IamAuthenticator{\n    ApiKey: \"{apikey}\",\n}\nschematicsv1.NewSchematicsV1(\n    &schematicsv1.SchematicsV1Options{\n        URL:           \"{url}\",\n        Authenticator: authenticator,\n    }\n)\n```\n\n## Authorization\n\nTo use the IBM Cloud Schematics API, you must be authorized to work with IBM Cloud Schematics. Schematics uses service access roles in Identity and Access Management (IAM) to determine the permissions that you have in Schematics. For more information about needed permissions, see [Managing user access](https://cloud.ibm.com/docs/schematics?topic=schematics-access).\n\nIf you are assigned an IBM Cloud Schematics service access role, you can view, create, update, delete, or run an action against your Workspaces in Schematics. To provision the IBM Cloud resources that you defined in your Terraform template, you must be assigned the IAM platform or service access role that is needed to provision the individual resource. For example, to provision an IBM Cloud Kubernetes Service cluster, you must have the **Administrator** platform role and the **Manager** service access role for IBM Cloud Kubernetes Service in addition to the permissions in IBM Cloud Schematics. Refer to the documentation for your resource to determine the access policies that you need to provision and work with your resource. \n\n## API endpoints\n\nIBM Cloud Schematics provides different APIs that you can use to create and work with Workspaces in specific locations. The API endpoint determines where your Schematics actions run and where your Workspace data is stored. By default, the information that is stored in Schematics is encrypted in transit and at rest. To ensure disaster recovery, your data is replicated to another location within the same region. Make sure that your data can be stored in these regions before you start by using Schematics. \n\nThe `GetServiceURLForRegion` function with the `x-ibm-region` parameters in the API returns the service URL to be used for the specified region. The following table lists the servers object in the API definition.\n\n|Location|API endpoint|Location where Schematics actions run|Data is stored in|Data is replicated to|\n|-------------|------------------|------|--------|-------|\n|North America|**Public**: `https://us.schematics.cloud.ibm.com` </br> | IBM Cloud Schematics jobs that are run in either the `us-south` or `us-east` location.|All metadata for the service features are stored in the `US` region.| Data is replicated between two locations in the US. |\n|Dallas|**Public**: `https://us-south.schematics.cloud.ibm.com` </br></br>**Private**: `https://private-us-south.schematics.cloud.ibm.com`|All IBM Cloud Schematics jobs run in the Dallas (`us-south`) location.|All metadata for the service features are stored in the Dallas (`us-south`) location.| Data is replicated between two locations in the US for disaster recovery purposes.|\n|Washington|**Public**: `https://us-east.schematics.cloud.ibm.com`  </br></br>**Private**: `https://private-us-east.schematics.cloud.ibm.com`|All IBM Cloud Schematics jobs run in the Washington (`us-east`) location.|All metadata for the service features are stored in the Washington (`us-east`) location.| Data is replicated between two locations in the US for disaster recovery purposes.|\n|Europe|**Public**: `https://eu.schematics.cloud.ibm.com` </br> | IBM Cloud Schematics actions that are run in either the `eu-de` or `eu-gb` location.| All metadata for the service features are stored in the `EU` region.| Data is replicated between two locations in Europe. |\n|Frankfurt|**Public**: `https://eu-de.schematics.cloud.ibm.com` </br></br>**Private**: `https://private-eu-de.schematics.cloud.ibm.com`| All IBM Cloud Schematics jobs run in the Frankfurt (`eu-de`) location.| All metadata for the service features are stored in the Frankfurt (`eu-de`) location.| Data is replicated between two locations in Europe for disaster recovery purposes.|\n|London|**Public**: `https://eu-gb.schematics.cloud.ibm.com` </br></br>**Private**: `https://private-eu-gb.schematics.cloud.ibm.com`| All IBM Cloud Schematics jobs run in the London (`eu-gb`) location.| All metadata for the service features are stored in the London (`eu-gb`) location.| Data is replicated between two locations in Europe for disaster recovery purposes.|\n|Toronto|**Public**: `https://ca-tor.schematics.cloud.ibm.com` </br></br>**Private**: `https://private-ca-tor.schematics.cloud.ibm.com`| All IBM Cloud Schematics jobs run in the Toronto (`ca-tor`) location.| All metadata for the service features are stored in the Toronto (`ca-tor`) location.| Data is replicated between three zones within `ca-tor` for high-availability.|\n|Montreal|**Public**: `https://ca-mon.schematics.cloud.ibm.com` </br></br>**Private**: `https://private-ca-mon.schematics.cloud.ibm.com`| All IBM Cloud Schematics jobs run in the Montreal (`ca-mon`) location.| All metadata for the service features are stored in the Montreal (`ca-mon`) location.| Data is replicated between three zones within `ca-mon` for high-availability.| \n\n## Versioning\n\nAll API requests require a major version in the path (`/v1/`).\n\n## Error handling\n\nThis API uses standard HTTP response codes to indicate whether a method completes successfully. A `200` response always indicates success. A `400` type response is sort of failure, and a `500` type response usually indicates an internal system error.\n\n| HTTP error code | Description | Recovery |\n|-----------------|-------------|----------|\n| `200` | `Success` | The request was successful. |\n| `400` | `Bad Request` | The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all needed parameters in your request. |\n| `401` | `Unauthorized` | You are not authorized to make this request. Log in to IBM Cloud and try again. If this error persists, contact the account owner to check your permissions.\t|\n| `403` | `Forbidden` | The supplied authentication is not authorized to access '{workspace}'. Check that you have the correct access credentials and permissions. |\n| `404` | `Not Found` | The requested resource might not be found. |\n| `408` | `Request Timeout` | The connection to the server timed out. Wait a few minutes, then try again. |\n| `409` | `Conflict` | The entity is already in the requested state. |\n| `429` | `Too Many Requests` | Too many requests are made within a time window. Wait and then call the API again. |\n| `500` | `Internal Server Error` | IBM Cloud Schematics is disabled. Your request might not be processed. Wait a few minutes and try again. If you still encounter this problem, note the incident ID and contact [IBM Cloud support](https://cloud.ibm.com/docs/schematics?topic=schematics-schematics-help). |\n| `503` |  `Service Temporarily Unavailable` | IBM Cloud Schematics might not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact [IBM Cloud support](https://cloud.ibm.com/docs/schematics?topic=schematics-schematics-help).|\n\n### Code example\n\nIf an error response from the server endpoint the Java SDK throws\nan exception from the `com.ibm.cloud.sdk.core.service.exception` package.\nThe base class for all exception classes is `ServiceResponseException` - that derives\nfrom unchecked `RuntimeException` - to handle any error response from the server.\nThe list provides predefined exceptions and their corresponding `statusCode` and `message` content.\n\n| Exception                 | Status Code and default error message         |\n|---------------------------|-----------------------------------------------|\n| ServiceResponseException  | Base class for all exceptions                 |\n| BadRequestException       | `400` Bad Request                             |\n| UnauthorizedException     | `401` Unauthorized                            |\n| ForbiddenException        | `403` Forbidden                               |\n| NotFoundException         | `404` Not found                               |\n| ConflictException         | `409` Conflict                                |\n| UnsupportedException      | `415` Unsupported media type                  |\n| InternalServerErrorException | `500` Internal server error                |\n| IllegalArgumentException  | An invalid argument was passed to the method. |\n\nAll service exceptions contain the following fields:\n\n| Field          | Description |\n|----------------|-------------|\n| statusCode     | HTTP response status code |\n| message        | the error message returned in the response |\n| debuggingInfo  | a `Map<String, Object>` that contains the unmarshalled error response object when a JSON error response is returned.<br/>It provides more information beyond the error message. |\n\nExample error handling\n\n```java\nimport com.ibm.cloud.sdk.core.service.exception.BadRequestException;\nimport com.ibm.cloud.sdk.core.service.exception.NotFoundException;\nimport com.ibm.cloud.sdk.core.service.exception.ServiceResponseException;\nimport com.ibm.cloud.sdk.core.service.exception.UnauthorizedException;\n\ntry {\n  // Invoke a Schematics method request\n} catch (BadRequestException e) {\n  // Handle Bad Request (400) exception\n} catch (UnauthorizedException e) {\n  // Handle Unauthorized (401) exception\n} catch (NotFoundException e) {\n  // Handle Not Found (404) exception\n} catch (ServiceResponseException se) {\n  System.out.println(\"Service returned status code \"\n    + se.getStatusCode() + \": \" + se.getMessage());\n  System.out.println(\"Detailed error info: \" + se.getDebuggingInfo().getOrDefault(\"reason\", \"\")););\n} catch (RuntimeException re) {\n  // Handle other error conditions\n  System.out.println(\"Unexpected Exception: \\n\" + re.getMessage());\n}\n```\n\n### Code example\n\nIf an error response from the server endpoint the Node SDK creates\nan `Error` object that contains either the HTTP response error message or a generic error message.\nIf the network problems the `axios` package generates an `Error` object.\nThis `Error` object is passed as the first parameter to the callback function,\nits failure describes the content as shown in the following table.\n\n| Field      | Description |\n|------------|-------------|\n| status     | HTTP response status code |\n| statusText | a text description of the status code |\n| message    | generic error message |\n| body       | the error response body as text |\n\nExample error handling\n\n```javascript\nservice.<Schematics API Method Request>(params)\n  .then((response) => {\n    // ...handle successful response...\n  })\n  .catch(error => {\n    console.log(\"Error status code: \" + error.status);\n    console.log(\"Error status text: \" + error.statusText);\n    console.log(\"Error message:     \" + error.message);\n    console.log(\"Error details:     \" + error.body)\n  });\n```\n\n### Code example\n\nIf an error response from the server endpoint the Python SDK\nthrows an `ApiException` that includes more information about the cause\nof the failure. It provides the following details:\n\n| Field   | Description |\n|---------|-------------|\n| code    | HTTP response status code |\n| message | the error message returned in the response |\n| reason  | a more detailed description about the cause of the failure |\n\nExample error handling\n\n```python\nfrom ibm_cloud_sdk_core import ApiException\n\ntry:\n  # Invoke a Schematics method request\nexcept ApiException as ae:\n  print(\"Method failed\")\n  print(\" - status code: \" + str(ae.code))\n  print(\" - error message: \" + ae.message)\n  if (\"reason\" in ae.http_response.json()):\n    print(\" - reason: \" + ae.http_response.json()[\"reason\"])\n\nfrom requests import ConnectionError, ReadTimeout, RequestException\n\ntry:\n  # Invoke a Schematics method request\nexcept ConnectionError as cerr:\n  print(\"Connection error occurred:\")\n  print(cerr)\nexcept ReadTimeout as rt:\n  # The server did not send any data in the allotted amount of time.\n  print(\"Read timed out:\")\n  print(rt)\nexcept RequestException as re:\n  # Handle other request failures\n  print(\"Request Exception:\")\n  print(re)\n```\n\n### Code example\n\nIf an error response from the server endpoint the Go SDK creates an `error`\nobject that contains either the HTTP response error message or a generic error message.\n\nAn extra `detailedResponse` is returned by the service\nthat contains the following fields:\n\n| Field      | Description |\n|------------|-------------|\n| StatusCode | HTTP response status code |\n| Result     | JSON error response object that is unmarshalled as `map[string]interface{}` |\n| RawResult  | raw non-JSON error response object as `[]byte` |\n\nExample error handling\n\n```go\n_, detailedResponse, err := // Invoke a Schematics method request\nif err != nil {\n    if (detailedResponse != nil) {\n      fmt.Println(\"Error status code: \", detailedResponse.StatusCode)\n      fmt.Println(\"Error message:     \", err.Error())\n      errorMap, ok := detailedResponse.GetResultAsMap(); if ok {\n        fmt.Println(\"Reason:          \", errorMap[\"reason\"])\n      }\n    } else {\n      // Handle other error conditions\n      fmt.Println(\"Error message: \", err.Error())\n    }\n  }\n```",
    "version": "1.0",
    "x-alternate-name": "schematics",
    "x-codegen-config": {
      "go": {
        "apiPackage": "github.com/IBM/schematics-go-sdk"
      }
    },
    "x-github": "https://github.ibm.com/cloud-api-docs/schematics",
    "x-github-issues": "https://github.ibm.com/cloud-api-docs/schematics/issues/new",
    "x-last-updated": "[{LAST_UPDATED_DATE}]"
  },
  "servers": [
    {
      "url": "https://schematics.cloud.ibm.com",
      "description": "Production server"
    },
    {
      "url": "https://schematics.test.cloud.ibm.com",
      "description": "Staging server"
    },
    {
      "url": "https://schematics-dev.containers.appdomain.cloud",
      "description": "Development server"
    }
  ],
  "tags": [
    {
      "name": "util",
      "description": "Schematics utility"
    },
    {
      "name": "workspaces",
      "description": "Organize your workspace definitions"
    },
    {
      "name": "actions",
      "description": "Organize your action templates and environment"
    },
    {
      "name": "jobs",
      "description": "Launch automation jobs and work with job records"
    },
    {
      "name": "bulk-jobs",
      "description": "Work with multiple automation jobs"
    },
    {
      "name": "inventory",
      "description": "Work with the inventory definition"
    },
    {
      "name": "agent",
      "description": "Work with the schematics agents (Beta)"
    },
    {
      "name": "settings-kms",
      "description": "KMS Settings for `USK`, `BYOK`, or `KYOK`"
    }
  ],
  "paths": {
    "/v2/locations": {
      "get": {
        "tags": [
          "util"
        ],
        "summary": "List supported locations",
        "description": "Retrieve a list of IBM Cloud locations where you can work with the Schematics objects.\n\n  <h3>Authorization</h3> \n\n  Schematics support generic authorization for its resources. \n  For more information, about Schematics access and permissions, \n  see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).",
        "operationId": "list_locations",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successfully listed all the locations.",
            "headers": {
              "X-Request-Id": {
                "description": "The unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SchematicsLocationsList"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/list_locations_200_response"
                  }
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "403": {
            "description": "Unauthorized access.  Check that you have the correct access credentials and permissions.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request to create the locations.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --location --request GET  https://schematics.cloud.ibm.com/v2/locations --header \"Authorization: <access_token> \" --header \"Content-Type: application/json\" --header \"X-Feature-Region-Visibility: true\""
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request to create the locations.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "schematics_locations_list = schematics_service.list_locations(headers={'X-Feature-Region-Visibility' : 'true'}).get_result()\n",
                      "print(json.dumps(schematics_locations_list, indent=2))\n"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request to create the locations.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListLocationsOptions listLocationsOptions = new ListLocationsOptions();\n",
                      "service.setDefaultHeaders(Collections.singletonMap(\"X-Feature-Region-Visibility\", \"true\"));\n",
                      "Response<SchematicsLocationsList> response3 = service.listLocations(listLocationsOptions).execute();\n",
                      "SchematicsLocationsList schematicsLocationsList = response3.getResult();\n",
                      "System.out.println(schematicsLocationsList);\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request to create the locations.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const header = {\n",
                      "\"X-Feature-Region-Visibility\":\"true\",\n",
                      "}\n",
                      "const params = {\n",
                      "headers : header\n",
                      "};\n",
                      "schematicsService.listLocations(params)\n",
                      ".then(res => {\n",
                      "console.log(JSON.stringify(res.result, null, 2));\n",
                      "})\n",
                      ".catch(err => {\n",
                      "console.warn(err)\n",
                      "});\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request to create the locations.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listLocationsOptions := schematicsService.NewListLocationsOptions()\n",
                      "schematicsLocationsList, response, err := schematicsService.ListLocations(listLocationsOptions)\n",
                      "if err != nil {\n",
                      "panic(err)\n",
                      "}\n",
                      "b, _ := json.MarshalIndent(schematicsLocationsList, \"\", \"  \")\n",
                      "fmt.Println(string(b))\n",
                      "fmt.Println(response)\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/resource_groups": {
      "get": {
        "tags": [
          "util"
        ],
        "summary": "List resource groups",
        "description": "Retrieve a list of IBM Cloud resource groups that your account has access to. \n\n  <h3>Authorization</h3> \n\n  Schematics support generic authorization for its resources. \n  For more information, about Schematics access and permissions, \n  see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).",
        "operationId": "list_resource_group",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successfully returned resource groups information.",
            "headers": {
              "X-Request-Id": {
                "description": "The unique ID for this request.",
                "schema": {
                  "type": "string"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/list_resource_group_200_response"
                  }
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/ResourceGroupResponse"
                  }
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET https://schematics.cloud.ibm.com/v1/resource_groups -H \"Authorization: <iam_token>\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listResourceGroupOptions := schematicsService.NewListResourceGroupOptions()\n",
                      "\n",
                      "resourceGroups, detailedResponse, err := schematicsService.ListResourceGroup(listResourceGroupOptions)\n",
                      "\n",
                      "if err != nil {\n",
                      "    panic(err)\n",
                      "}\n",
                      "\n",
                      "w, err := json.MarshalIndent(resourceGroups, \"\", \"  \")\n",
                      "fmt.Println(string(w))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "schematicsService.listResourceGroup({})\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "list_resource_group_response = schematics_service.list_resource_group().get_result()\n",
                      "\n",
                      "print(json.dumps(list_resource_group_response, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListResourceGroupOptions listResourceGroupOptions = new ListResourceGroupOptions();\n",
                      "\n",
                      "Response<List<ResourceGroupResponse>> response = service.listResourceGroup(listResourceGroupOptions).execute();\n",
                      "List<ResourceGroupResponse> listResourceGroupResponse = response.getResult();\n",
                      "\n",
                      "System.out.println(listResourceGroupResponse);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/version": {
      "get": {
        "tags": [
          "util"
        ],
        "summary": "Get Schematics API information",
        "description": "Retrieve detailed information about the IBM Cloud Schematics API version and the version of the provider plug-ins that the API uses.",
        "operationId": "get_schematics_version",
        "responses": {
          "200": {
            "description": "Successfully returned version information.",
            "headers": {
              "X-Request-Id": {
                "description": "The unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/VersionResponse"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/get_schematics_version_200_response"
                  }
                }
              }
            }
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET https://schematics.cloud.ibm.com/v1/version"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "schematicsVersion, detailedResponse, err := schematicsService.GetSchematicsVersion(&schematicsv1.GetSchematicsVersionOptions{})\n",
                      "if err != nil {\n",
                      "  panic(err)\n",
                      "}\n",
                      "\n",
                      "b, _ := json.MarshalIndent(schematicsVersion, \"\", \"  \")\n",
                      "fmt.Println(string(b))\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "schematicsService.getSchematicsVersion({})\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "version_response = schematics_service.get_schematics_version().get_result()\n",
                      "\n",
                      "print(json.dumps(version_response, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetSchematicsVersionOptions getSchematicsVersionOptions = new GetSchematicsVersionOptions();\n",
                      "\n",
                      "Response<VersionResponse> response = service.getSchematicsVersion(getSchematicsVersionOptions).execute();\n",
                      "VersionResponse versionResponse = response.getResult();\n",
                      "\n",
                      "System.out.println(versionResponse);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/workspaces": {
      "get": {
        "tags": [
          "workspaces"
        ],
        "summary": "List workspaces",
        "description": "Retrieve a list of Schematics workspaces from your IBM Cloud account that you have access to. The list of workspaces that is returned depends on the API endpoint that you use. For example, if you use an API endpoint for a geography, such as North America, only workspaces that are created in `us-south` or `us-east` are returned. \n\n For more information about supported API endpoints, see [API endpoints](/apidocs/schematics#api-endpoints).\n\n  <h3>Authorization</h3> \n\n  Schematics support generic authorization for its resources. \n  For more information, about Schematics access and permissions, \n  see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).",
        "operationId": "list_workspaces",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "offset",
            "in": "query",
            "description": "The starting position of the item in the list of items. For example, if you have three workspaces in your account, the first workspace is assigned position number 0, the second workspace is assigned position number 1, and so forth. If you have 6 workspaces and you want to list the details for workspaces `2-6`, enter 1. To limit the number of workspaces that is returned, use the `limit` option in addition to the `offset` option. Negative numbers are not supported and are ignored.",
            "required": false,
            "schema": {
              "maximum": 2000,
              "minimum": 0,
              "type": "integer"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The maximum number of items that you want to list. The number must be a positive integer between 1 and 2000. If no value is provided, 100 is used by default.",
            "required": false,
            "schema": {
              "maximum": 2000,
              "minimum": 1,
              "type": "integer",
              "default": 100
            }
          },
          {
            "name": "profile",
            "in": "query",
            "description": "Level of details returned by the get method",
            "required": false,
            "schema": {
              "type": "string",
              "enum": [
                "ids",
                "summary"
              ]
            }
          },
          {
            "name": "resource_group",
            "in": "query",
            "description": "The resource group (by default, fetch from all resource groups) name or ID",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "Successfully listed the workspaces that you have access to.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WorkspaceResponseList"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/list_workspaces_200_response"
                  }
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "403": {
            "description": "Unauthorized access.  Check that you have the correct access credentials and permissions.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-ibm-events": {
          "summary": "Auditing",
          "events": [
            {
              "name": "schematics.workspace.list"
            }
          ]
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET https://schematics.cloud.ibm.com/v1/workspaces -H \"Authorization: <iam_token>\"    "
                    ]
                  }
                ]
              },
              {
                "name": "Example request for list workspace with profile defining summary.",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET https://schematics.cloud.ibm.com/v1/workspaces?profile=summary -H \"Authorization: <iam_token>\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "listWorkspacesOptions := schematicsService.NewListWorkspacesOptions()\n",
                      "\n",
                      "workspaceList, detailedResponse, err := schematicsService.ListWorkspaces(listWorkspacesOptions)\n",
                      "\n",
                      "if err != nil {\n",
                      "    panic(err)\n",
                      "}\n",
                      "\n",
                      "w, err := json.MarshalIndent(workspaceList, \"\", \"  \")\n",
                      "fmt.Println(string(w))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "schematicsService.listWorkspaces({})\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workspace_response_list = schematics_service.list_workspaces().get_result()\n",
                      "\n",
                      "print(json.dumps(workspace_response_list, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "ListWorkspacesOptions listWorkspacesOptions = new ListWorkspacesOptions.Builder()\n",
                      ".build();\n",
                      "\n",
                      "Response<WorkspaceResponseList> response = service.listWorkspaces(listWorkspacesOptions).execute();\n",
                      "WorkspaceResponseList workspaceResponseList = response.getResult();\n",
                      "\n",
                      "System.out.println(workspaceResponseList);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "post": {
        "tags": [
          "workspaces"
        ],
        "summary": "Create a workspace",
        "description": "Create an IBM Cloud Schematics workspace that points to the source repository where your Terraform template or the IBM Cloud software template is stored. You can decide to create your workspace without connecting it to a GitHub or GitLab repository. Your workspace is then created with a **Draft** state. To later connect your workspace to a GitHub or GitLab repository, you must use the `PUT /v1/workspaces/{id}` API to update the workspace or use the `/v1/workspaces/{id}/templates/{template_id}/template_repo_upload` API to upload a TAR file instead. \n\n **Getting API endpoint**:- \n\n * The Schematics API endpoint that you use to create the workspace determines where your Schematics actions run and your data is stored. See [API endpoints](/apidocs/schematics#api-endpoints) for more information. \n * If you use the API endpoint for a geography and not a specific location, such as North America, you can specify the location in your API request body. \n * If you do not specify the location in the request body, Schematics determines your workspace location based on availability. \n * If you use an API endpoint for a specific location, such as Frankfurt, the location that you enter in your API request body must match your API endpoint. \n * You also have the option to not specify a location in your API request body if you use a location-specific API endpoint. \n\n **Getting IAM access token** :- \n * Before you create Schematics workspace, you need to create the IAM access token for your IBM Cloud Account. \n * To create IAM access token, use `export IBMCLOUD_API_KEY=<ibmcloud_api_key>` and execute `curl -X POST \"https://iam.cloud.ibm.com/identity/token\" -H \"Content-Type= application/x-www-form-urlencoded\" -d \"grant_type=urn:ibm:params:oauth:grant-type:apikey&apikey=$IBMCLOUD_API_KEY\" -u bx:bx`. For more information, about creating IAM access token and API Docs, see [IAM access token](/apidocs/iam-identity-token-api#gettoken-password) and [Create API key](/apidocs/iam-identity-token-api#create-api-key). \n * You can set the environment values  `export ACCESS_TOKEN=<access_token>` and `export REFRESH_TOKEN=<refresh_token>`. \n * You can use the obtained IAM access token in create workspace `curl` command.\n\n  <h3>Authorization</h3> \n\n  Schematics support generic authorization for its resources. \n  For more information, about Schematics access and permissions, \n  see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).",
        "operationId": "create_workspace",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "X-Github-token",
            "in": "header",
            "description": "The personal access token to authenticate with your private GitHub or GitLab repository and access your Terraform template.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Input parameter to create the IBM Cloud Schematics workspace.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WorkspaceCreateRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "201": {
            "description": "Successfully created the workspace in IBM Cloud Schematics. Your resources are not provisioned until you use the `POST /workspaces/{id}/apply` API.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WorkspaceResponse"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/create_workspaces_200_response"
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad request - Verify that the information in your request body is complete and correctly formatted in JSON.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "403": {
            "description": "Unauthorized access.  Check that you have the correct access credentials and permissions.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "404": {
            "description": "The workspace already exists. To find a list of workspaces, use the `GET /workspaces` API.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "409": {
            "description": "The workspace is frozen and disabled. Unfreeze the workspace first  before you retry the request. Or the Schematics create, update,  delete action has not completed. Wait until the create, update,  delete, plan, apply, destroy or refresh action completes before you try again.          ",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "429": {
            "description": "Too many requests have been made within a time window. \"IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region\". Wait before calling the API again.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "503": {
            "description": "IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-ibm-events": {
          "summary": "Auditing",
          "events": [
            {
              "name": "schematics.workspace.create"
            }
          ]
        },
        "x-codegen-request-body-name": "workspace",
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request to create a workspace with a link to a GitHub repository",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --request POST --url https://schematics.cloud.ibm.com/v1/workspaces -H \"Authorization: Bearer <access_token>\" -d '{\"name\":\"<workspace_name>\",\"type\": [\"terraform_v1.0\"],\"location\": \"<location>\",\"description\": \"<workspace_description>\",\"resource_group\": \"<resource_group_ID>\",\"tags\": [],\"template_repo\": {\"url\": \"<source_repo_url>\"},\"template_data\": [{\"folder\": \".\",\"type\": \"terraform_v1.0\",\"variablestore\": [{\"name\": \"variable_name1\",\"value\": \"variable_value1\"},{\"name\": \"variable_name2\",\"value\": \"variable_value2\"}]}]}'"
                    ]
                  }
                ]
              },
              {
                "name": "Example request to create a workspace without a GitHub repository URL to upload a TAR file later",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --request POST --url https://schematics.cloud.ibm.com/v1/workspaces -H \"Authorization: Bearer <access_token>\" -d '{\"name\":\"<workspace_name>\",\"type\": [\"terraform_v1.0\"],\"location\": \"<location>\",\"description\": \"<workspace_description>\",\"resource_group\": \"<resource_group_ID>\",\"tags\": [],\"template_repo\": {\"url\": \"\"},\"template_data\": [{\"folder\": \".\",\"type\": \"terraform_v1.0\",\"variablestore\": [{\"name\": \"variable_name1\",\"value\": \"variable_value1\"},{\"name\": \"variable_name2\",\"value\": \"variable_value2\"}]}]}'"
                    ]
                  }
                ]
              },
              {
                "name": "Example request to create a workspace with an environment variables",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --request POST --url https://schematics.cloud.ibm.com/v1/workspaces -H  Content-Type: application/json Authorization: Bearer <access_token>\" -d '{\"name\":\"<workspace_name>\",\"type\": [\"terraform_v1.0\"],\"description\": \"terraform workspace\",\"tags\":[  \"department:HR\", \"application:compensation\",\"environment:staging\"], \"template_repo\":{\"url\":\"https://github.com/ptaube/tf_cloudless_sleepy\" },\"workspace_status\":{\"frozen\":true},\"template_data\":[{   \"folder\":\".\",\"type\":\"terraform_v1.0\",\"variablestore\":[ {\"name\":\"sample_var\",\"secure\":false,\"value\":\"THIS IS IBM CLOUD TERRAFORM CLI DEMO\", \"description\":\"Description of sample_var\"},{   \"name\":\"sleepy_time\",\"value\":\"15\"}]}]}'"
                    ]
                  }
                ]
              },
              {
                "name": "Example request to create a workspace with an .netrc environment variables",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --request POST --url https://schematics.cloud.ibm.com/v1/workspaces -H 'authorization: Bearer <access_token>' \\ 'cache-control: no-cache' \\ 'content-type: application/json' \\ 'postman-token: dc2ea316-12a3-597b-4353-3150078d5d5e' \\ '{\"name\": \"<workspace_name>\",\"shared_data\": {\"region\": \"us-south\"}, \"type\": [\"terraform_v1.0\"], \"description\": \"terraform workspace\", \"template_repo\": {\"url\": \"https://github.com/msundeep4/test-template-private-module\"}, \"template_data\": [ {\"folder\": \".\",\"type\": \"terraform_v1.0\", \"env_values\": [{\"__netrc__\":\"[['github.com','msundeep4','<githubtoken>']]\"}] }]}'                "
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "templateSourceDataRequestModel := &schematicsv1.TemplateSourceDataRequest{\n",
                      "    Folder: core.StringPtr(\".\"),\n",
                      "    Type:   core.StringPtr(\"terraform_v1.0\"),\n",
                      "    Variablestore: []schematicsv1.WorkspaceVariableRequest{\n",
                      "        {\n",
                      "            Name:  core.StringPtr(\"<variable_name1>\"),\n",
                      "            Value: core.StringPtr(\"<variable_value1>\"),\n",
                      "        },\n",
                      "        {\n",
                      "            Name:  core.StringPtr(\"<variable_name2>\"),\n",
                      "            Value: core.StringPtr(\"<variable_value2>\"),\n",
                      "        },\n",
                      "    },\n",
                      "}\n",
                      "\n",
                      "templateRepoRequestModel := &schematicsv1.TemplateRepoRequest{\n",
                      "    URL: core.StringPtr(\"<source_repo_url>\"),\n",
                      "}\n",
                      "\n",
                      "createWorkspaceOptions := &schematicsv1.CreateWorkspaceOptions{\n",
                      "    Description:   core.StringPtr(\"<description>\"),\n",
                      "    Name:          core.StringPtr(\"<workspace_name>\"),\n",
                      "    TemplateData:  []schematicsv1.TemplateSourceDataRequest{*templateSourceDataRequestModel},\n",
                      "    TemplateRepo:  templateRepoRequestModel,\n",
                      "    Type:          []string{\"terraform_v1.0\"},\n",
                      "    Location:      core.StringPtr(\"<location>\"),\n",
                      "    ResourceGroup: core.StringPtr(\"<resource_group>\"),\n",
                      "    Tags:          []string{\"<tags>\"},\n",
                      "}\n",
                      "\n",
                      "workspaceResponse, detailedResponse, err := schematicsService.CreateWorkspace(createWorkspaceOptions)\n",
                      "\n",
                      "if err != nil {\n",
                      "    panic(err)\n",
                      "}\n",
                      "\n",
                      "w, err := json.MarshalIndent(workspaceResponse, \"\", \"  \")\n",
                      "fmt.Println(string(w))\n",
                      ""
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const templateSourceDataRequestModel = {\n",
                      "  folder: '.',\n",
                      "  type: 'terraform_v1.0',\n",
                      "  variablestore: [\n",
                      "    {\n",
                      "      name: '<variable_name1>',\n",
                      "      value: '<variable_value1>',\n",
                      "    },\n",
                      "    {\n",
                      "      name: '<variable_name2>',\n",
                      "      value: '<variable_value2>',\n",
                      "    }\n",
                      "  ]\n",
                      "};\n",
                      "\n",
                      "const templateRepoRequestModel = {\n",
                      "  url: '<source_repo_url>,\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  description: '<description>',\n",
                      "  name: '<workspace_name>',\n",
                      "  templateData: [templateSourceDataRequestModel],\n",
                      "  templateRepo: templateRepoRequestModel,\n",
                      "  type: ['terraform_v1.0'],\n",
                      "  location: '<location>',\n",
                      "  resourceGroup: '<resource_group>'\n",
                      "  tags: ['<tags>'],\n",
                      "};\n",
                      "\n",
                      "schematicsService.createWorkspace(params)\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workspace_variable_request_model = {}\n",
                      "workspace_variable_request_model['name'] = 'variable_name1'\n",
                      "workspace_variable_request_model['value'] = 'variable_value1'\n",
                      "\n",
                      "template_source_data_request_model = {}\n",
                      "template_source_data_request_model['env_values'] = [{ 'foo': 'bar' }]\n",
                      "template_source_data_request_model['folder'] = 'testString'\n",
                      "template_source_data_request_model['type'] = 'terraform_v1.0'\n",
                      "template_source_data_request_model['variablestore'] = [workspace_variable_request_model]\n",
                      "\n",
                      "template_repo_request_model = {}\n",
                      "template_repo_request_model['url'] = '<source_repo_url>'\n",
                      "\n",
                      "\n",
                      "workspace_response = schematics_service.create_workspace(\n",
                      "    description=\"<description>\", \n",
                      "    name=\"<workspace_name>\",\n",
                      "    template_data=[template_source_data_request_model],\n",
                      "    template_repo=template_repo_request_model,\n",
                      "    type=['terraform_v1.0'],\n",
                      "    location=\"<location>\",\n",
                      "    resource_group=\"<resource_group>\",\n",
                      "    tags=['<tags>'],\n",
                      ").get_result()\n",
                      "\n",
                      "print(json.dumps(workspace_response, indent = 2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Construct an instance of the WorkspaceVariableRequest model\n",
                      "WorkspaceVariableRequest workspaceVariableRequestModel = new WorkspaceVariableRequest.Builder()\n",
                      ".name(\"variable_name1\")\n",
                      ".value(\"variable_value1\")\n",
                      ".build();\n",
                      "\n",
                      "// Construct an instance of the TemplateSourceDataRequest model\n",
                      "TemplateSourceDataRequest templateSourceDataRequestModel = new TemplateSourceDataRequest.Builder()\n",
                      ".folder(\".\")\n",
                      ".type(\"terraform_v1.0\")\n",
                      ".variablestore(new java.util.ArrayList<WorkspaceVariableRequest>(java.util.Arrays.asList(workspaceVariableRequestModel)))\n",
                      ".build();\n",
                      "\n",
                      "// Construct an instance of the TemplateRepoRequest model\n",
                      "TemplateRepoRequest templateRepoRequestModel = new TemplateRepoRequest.Builder()\n",
                      ".url(\"<source_repo_url>\")\n",
                      ".build();\n",
                      "\n",
                      "CreateWorkspaceOptions createWorkspaceOptions = new CreateWorkspaceOptions.Builder()\n",
                      ".description(\"<description>\")\n",
                      ".name(\"<workspace_name>\")\n",
                      ".templateData(new java.util.ArrayList<TemplateSourceDataRequest>(java.util.Arrays.asList(templateSourceDataRequestModel)))\n",
                      ".templateRepo(templateRepoRequestModel)\n",
                      ".type(new java.util.ArrayList<String>(java.util.Arrays.asList(\"terraform_v1.0\")))\n",
                      ".location(\"<location>\")\n",
                      ".resourceGroup(\"<resource_group>\")\n",
                      ".tags(new java.util.ArrayList<String>(java.util.Arrays.asList(\"<tags>\")))\n",
                      ".build();\n",
                      "\n",
                      "Response<WorkspaceResponse> response = service.createWorkspace(createWorkspaceOptions).execute();\n",
                      "WorkspaceResponse workspaceResponse = response.getResult();\n",
                      "\n",
                      "System.out.println(workspaceResponse);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/workspaces/{w_id}": {
      "get": {
        "tags": [
          "workspaces"
        ],
        "summary": "Get workspace details",
        "description": "Retrieve detailed information for a workspace in your IBM Cloud account. \n\n <h3>Authorization</h3> \n\n Schematics support generic authorization for its resources. \n For more information, about Schematics access and permissions, see [Schematics service access \n roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles). ",
        "operationId": "get_workspace",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "w_id",
            "in": "path",
            "description": "The ID of the workspace.  To find the workspace ID, use the `GET /v1/workspaces` API.",
            "required": true,
            "schema": {
              "type": "string"
            },
            "x-cli-option-name": "workspace_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Successfully retrieved details about your workspace.",
            "headers": {
              "X-Request-Id": {
                "description": "The unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WorkspaceResponse"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/get_workspace_200_response"
                  }
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "403": {
            "description": "Unauthorized access.  Check that you have the correct access credentials and permissions.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-ibm-events": {
          "summary": "Auditing",
          "events": [
            {
              "name": "schematics.workspace.read"
            }
          ]
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET https://schematics.cloud.ibm.com/v1/workspaces/{id} -H \"Authorization: Bearer <iam_token>\""
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workspaceDetails, detailedResponse, err := schematicsService.GetWorkspace(&schematicsv1.GetWorkspaceOptions{\n",
                      "    WID: <workspace_id>,\n",
                      "})\n",
                      "\n",
                      "if err != nil {\n",
                      "    panic(err)\n",
                      "}\n",
                      "\n",
                      "w, err := json.MarshalIndent(workspaceDetails, \"\", \"  \")\n",
                      "fmt.Println(string(w))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const params = {\n",
                      "  wId: '<workspace_id>',\n",
                      "};\n",
                      "\n",
                      "schematicsService.getWorkspace(params)\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "workspace_response = schematics_service.get_workspace(\n",
                      "    w_id='<workspace_id>'\n",
                      ").get_result()\n",
                      "\n",
                      "print(json.dumps(workspace_response, indent=2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "GetWorkspaceOptions getWorkspaceOptions = new GetWorkspaceOptions.Builder()\n",
                      ".wId(\"<workspace_id>\")\n",
                      ".build();\n",
                      "\n",
                      "Response<WorkspaceResponse> response = service.getWorkspace(getWorkspaceOptions).execute();\n",
                      "WorkspaceResponse workspaceResponse = response.getResult();\n",
                      "\n",
                      "System.out.println(workspaceResponse);"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "put": {
        "tags": [
          "workspaces"
        ],
        "summary": "Update workspace",
        "description": "Use this API to update or replace the entire workspace, including the Terraform template (`template_repo`) or IBM Cloud catalog software template (`catalog_ref`) that your workspace points to.  \n\n **Tip**:- If you want to update workspace metadata, use the `PATCH /v1/workspaces/{id}` API. \n To update workspace variables, use the `PUT /v1/workspaces/{id}/template_data/{template_id}/values` API. \n\n <h3>Authorization</h3> \n\n Schematics support generic authorization for its resources. \n For more information, about Schematics access and permissions, \n see [Schematics service access roles and required permissions](https://cloud.ibm.com/docs/schematics?topic=schematics-access#access-roles).\n ",
        "operationId": "replace_workspace",
        "parameters": [
          {
            "name": "Authorization",
            "in": "header",
            "description": "The IAM access token for your IBM Cloud account.  You can use the client ID and the secret that are used by the IBM Cloud command line 'bx / bx'.  To retrieve the token, run `ic iam oauth-tokens` in the IBM Cloud command line.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "X-Github-token",
            "in": "header",
            "description": "The personal access token to authenticate with your private GitHub or GitLab repository and access your Terraform template.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "w_id",
            "in": "path",
            "description": "The ID of the workspace.  To find the workspace ID, use the `GET /v1/workspaces` API.",
            "required": true,
            "schema": {
              "type": "string"
            },
            "x-cli-option-name": "workspace_id"
          }
        ],
        "requestBody": {
          "description": "Replace the Workspace definition.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/WorkspaceUpdateRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "Successfully updated the workspace metadata.",
            "headers": {
              "X-Request-Id": {
                "description": "The unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WorkspaceResponse"
                },
                "examples": {
                  "response": {
                    "$ref": "#/components/examples/replace_workspace_200_response"
                  }
                }
              }
            }
          },
          "401": {
            "description": "The IAM authorization token for the request is missing, invalid, expired, or has no account. Check that the token value is correct or generate a new token with the `ibmcloud iam oauth-tokens` command.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "403": {
            "description": "Unauthorized access.  Check that you have the correct access credentials and permissions.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "404": {
            "description": "Not found. The specified workspace could not be found. Verify that the workspace ID is correct. To list workspaces in your IBM Cloud account, use the `GET /v1/workspaces API`.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "409": {
            "description": "The workspace is frozen and disabled. Unfreeze the workspace first  before you retry the request. Or the Schematics create, update,  delete action has not completed. Wait until the create, update,  delete, plan, apply, destroy or refresh action completes before you try again.          ",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "429": {
            "description": "Too many requests have been made within a time window. \"IBM Cloud Schematics supports 50 API requests per minute, per host, and per customer. The host can be `us-east`, `us-south`, `eu-gb`, or `eu-de` region\". Wait before calling the API again.",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "500": {
            "description": "Internal server error. IBM Cloud Schematics is currently unavailable. Wait a few minutes, then try again. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          },
          "503": {
            "description": "IBM Cloud Schematics could not process the request, due to a temporary overloading or maintenance. Try to reduce your request rate, or retry after a few minutes. If the error persists, contact [IBM Cloud support](/docs/schematics?topic=schematics-schematics-help).",
            "headers": {
              "X-Request-Id": {
                "description": "Unique ID for this request.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/APIResponseMessage"
                }
              }
            }
          }
        },
        "x-ibm-events": {
          "summary": "Auditing",
          "events": [
            {
              "name": "schematics.workspace.update"
            }
          ]
        },
        "x-codegen-request-body-name": "workspace",
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl --request PUT --url https://schematics.cloud.ibm.com/v1/workspaces/{id} -H  Authorization: <iam_token>\" -d '{\"name\":\"testWorkspaceApi\",\"type\":[   \"terraform_v1.0\"],\"description\":\"terraform workspace updated\", \"tags\":[\"department:HR\",\"application:compensation\",\"environment:staging\"], \"template_repo\":{\"url\":\"https://github.com/ptaube/tf_cloudless_sleepy\"}, \"workspace_status\":{\"frozen\":true},\"template_data\":[{\"folder\":\".\", \"type\":\"terraform_v1.0\",\"variablestore\":[{\"name\":\"sample_var\",\"secure\":false,\"value\":\"THIS IS IBM CLOUD TERRAFORM CLI DEMO\", \"description\":\"Description of sample_var\"},{\"name\":\"sleepy_time\",\"value\":\"15\"}]}]}'"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "templateRepoRequestUpdateModel := &schematicsv1.TemplateRepoUpdateRequest{\n",
                      "    URL: core.StringPtr(\"<source_repo_url>\"),\n",
                      "    RepoURL: core.StringPtr(\"<catalog_repo_url>\"),\n",
                      "}\n",
                      "\n",
                      "replaceWorkspaceOptions := &schematicsv1.ReplaceWorkspaceOptions{\n",
                      "    WID:          ws.ID,\n",
                      "    TemplateRepo: templateRepoRequestUpdateModel,\n",
                      "    CatalogRef: &schematicsv1.CatalogRef{\n",
                      "        ItemID:          core.StringPtr(\"<item_id>\"),\n",
                      "        ItemName:        core.StringPtr(\"<item_name>\"),\n",
                      "        ItemURL:         core.StringPtr(\"<item_url>\"),\n",
                      "        ItemReadmeURL:   core.StringPtr(\"<item_readme_url>\"),\n",
                      "        ItemIconURL:     core.StringPtr(\"<item_icon_url>\"),\n",
                      "        OfferingVersion: core.StringPtr(\"<offering_version>\"),\n",
                      "        LaunchURL:       core.StringPtr(\"<launch_url>\"),\n",
                      "    },\n",
                      "}\n",
                      "\n",
                      "replaceResponse, detailedResponse, err := schematicsService.ReplaceWorkspace(replaceWorkspaceOptions)\n",
                      "\n",
                      "if err != nil {\n",
                      "    panic(err)\n",
                      "}\n",
                      "\n",
                      "w, err := json.MarshalIndent(replaceResponse, \"\", \"  \")\n",
                      "fmt.Println(string(w))"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "const catalogRefModel = {\n",
                      "  item_icon_url: '<item_icon_url>',\n",
                      "  item_id: '<item_id>',\n",
                      "  item_name: '<item_name>',\n",
                      "  item_readme_url: '<item_readme_url>',\n",
                      "  item_url: '<item_url>',\n",
                      "  launch_url: '<launch_url>',\n",
                      "  offering_version: '<offering_version>',\n",
                      "};\n",
                      "\n",
                      "const templateRepoUpdateRequestModel = {\n",
                      "  repo_url: '<catalog_repo_url>',\n",
                      "  url: '<source_repo_url>',\n",
                      "};\n",
                      "\n",
                      "const params = {\n",
                      "  wId: '<workspace_id>',\n",
                      "  templateRepo: templateRepoUpdateRequestModel,\n",
                      "  catalogRef: catalogRefModel\n",
                      "};\n",
                      "\n",
                      "schematicsService.replaceWorkspace(params)\n",
                      "  .then(res => {\n",
                      "    console.log(JSON.stringify(res.result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.warn(err)\n",
                      "  });"
                    ]
                  }
                ]
              }
            ],
            "python": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "catalog_ref_model = {}\n",
                      "catalog_ref_model['item_icon_url'] = '<item_icon_url>'\n",
                      "catalog_ref_model['item_id'] = '<item_id>'\n",
                      "catalog_ref_model['item_name'] = '<item_name>'\n",
                      "catalog_ref_model['item_readme_url'] = '<item_readme_url>'\n",
                      "catalog_ref_model['item_url'] = '<item_url>'\n",
                      "catalog_ref_model['launch_url'] = '<launch_url>'\n",
                      "catalog_ref_model['offering_version'] = '<offering_version>'\n",
                      "\n",
                      "workspace_variable_request_model = {}\n",
                      "workspace_variable_request_model['name'] = 'variable_name1'\n",
                      "workspace_variable_request_model['value'] = 'variable_value1'\n",
                      "\n",
                      "template_source_data_request_model = {}\n",
                      "template_source_data_request_model['variablestore'] = [workspace_variable_request_model]\n",
                      "\n",
                      "template_repo_request_model = {}\n",
                      "template_repo_request_model['url'] = '<source_repo_url>'\n",
                      "\n",
                      "workspace_response = schematics_service.replace_workspace(\n",
                      "    w_id='<workspace_id>',\n",
                      "    description=\"<description>\", \n",
                      "    name=\"<workspace_name>\",\n",
                      "    catalog_ref=catalog_ref_model,\n",
                      "    template_data=[template_source_data_request_model],\n",
                      "    template_repo=template_repo_request_model,\n",
                      "    type=['terraform_v0.12.20'],\n",
                      "    location=\"<location>\",\n",
                      "    resource_group=\"<resource_group>\",\n",
                      "    tags=['<tags>'],\n",
                      ").get_result()\n",
                      "\n",
                      "print(json.dumps(workspace_response, indent = 2))"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "// Construct an instance of the CatalogRef model\n",
                      "CatalogRef catalogRefModel = new CatalogRef.Builder()\n",
                      ".itemIconUrl(\"<item_icon_url>\")\n",
                      ".itemId(\"<item_id>\")\n",
                      ".itemName(\"<item_name>\")\n",
                      ".itemReadmeUrl(\"<item_readme_url>\")\n",
                      ".itemUrl(\"<item_url>\")\n",
                      ".launchUrl(\"<launch_url>\")\n",
                      ".offeringVersion(\"<offering_version>\")\n",
                      ".build();\n",
                      "\n",
                      "// Construct an instance of the TemplateRepoUpdateRequest model\n",
                      "TemplateRepoUpdateRequest templateRepoUpdateRequestModel = new TemplateRepoUpdateRequest.Builder()\n",
                      ".repoUrl(\"<catalog_repo_url>\")\n",
                      ".url(\"<source_repo_url>\")\n",
                      ".build();\n",
                      "\n",
                      "ReplaceWorkspaceOptions replaceWorkspaceOptions = new ReplaceWorkspaceOptions.Builder()\n",
                      ".wId(\"<workspace_id>\")\n",
                      ".catalogRef(catalogRefModel)\n",
                      ".templateRepo(templateRepoUpdateRequestModel)\n",
                      ".build();\n",
                      "\n",
                      "Response<WorkspaceResponse> response = service.replaceWorkspace(replaceWorkspaceOptions).execute();\n",
                      "WorkspaceResponse workspaceResponse = response.getResult();"
                    ]
                  }
                ]
              }
[...]
